/* $Id: fsu_ls.h,v 1.1 2008/07/09 10:33:35 stacktic Exp $ */

/*
 * Copyright (c) 2008 Arnaud Ysmal.  All Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef _FSU_LS_H_
#define _FSU_LS_H_

#include "fsu_flist.h"

#define FSU_LS_SHOW_ALL_BUT_DOT (0x01)
#define FSU_LS_SHOW_ALL (FSU_LS_SHOW_ALL_BUT_DOT<<1)
#define FSU_LS_CHANGED_TIME (FSU_LS_SHOW_ALL<<1)
#define FSU_LS_DISPLAY_TYPE (FSU_LS_CHANGED_TIME<<1)
#define FSU_LS_LONG (FSU_LS_DISPLAY_TYPE<<1)
#define FSU_LS_NUMID (FSU_LS_LONG<<1)
#define FSU_LS_DISPLAY_DIRTYPE (FSU_LS_NUMID<<1)
#define FSU_LS_RECURSIVE (FSU_LS_DISPLAY_DIRTYPE<<1)
#define FSU_LS_FULLTIME (FSU_LS_RECURSIVE<<1)
#define FSU_LS_ACCESS_TIME (FSU_LS_FULLTIME<<1)
#define FSU_LS_REVERSE (FSU_LS_ACCESS_TIME<<1)
#define FSU_LS_SORT_SIZE (FSU_LS_REVERSE<<1)
#define FSU_LS_SORT_MODIFIED (FSU_LS_SORT_SIZE<<1)
#define FSU_LS_DIR_AS_FILE (FSU_LS_SORT_MODIFIED<<1)

int fsu_ls_parse_arg(int *, char ***);

int	 acccmp(const FSU_FENT **, const FSU_FENT **);
int	 revacccmp(const FSU_FENT **, const FSU_FENT **);
int	 modcmp(const FSU_FENT **, const FSU_FENT **);
int	 revmodcmp(const FSU_FENT **, const FSU_FENT **);
int	 namecmp(const FSU_FENT **, const FSU_FENT **);
int	 revnamecmp(const FSU_FENT **, const FSU_FENT **);
int	 statcmp(const FSU_FENT **, const FSU_FENT **);
int	 revstatcmp(const FSU_FENT **, const FSU_FENT **);
int	 sizecmp(const FSU_FENT **, const FSU_FENT **);
int	 revsizecmp(const FSU_FENT **, const FSU_FENT **);

#endif /* !_FSU_LS_H_ */
