#!/bin/sh
#
# $Id: fsu_cp_ffs.sh,v 1.1 2008/07/09 10:35:37 stacktic Exp $

init_fsu()
{
    echo "Building image";
    /usr/sbin/makefs -s 100m -t ffs rump_ffs.img /usr/src/sys/rump 2>&1 > /dev/null
    echo "Building fsu_*";
    cd ..
    make 2>&1 > /dev/null;
    cd -
}

clean_fsu()
{
    rm -f rump_ffs.img
}

test_fsu_cp()
{
	echo "Testing $1"

	../fsu_cp/fsu_cp -PR ffs rump_ffs.img $1 $1.cp;
	result=`../fsu_diff/fsu_diff ffs rump_ffs.img $1 $1.cp`
	../fsu_rm/fsu_rm -R ffs rump_ffs.img $1.cp;
	if [ $result ]; then
		echo "Test failed"
		exit 1
	fi
}

init_fsu
test_fsu_cp "Makefile" # test a file
test_fsu_cp "/librump/rumpkern/rump.c" # test a file biger than the buffer
test_fsu_cp "/fs/bin/fsconsole" # test a directory
clean_fsu
